#ifndef TETRAHEDRON_H
#define TETRAHEDRON_H

#include <QGLWidget>

class Tetrahedron : public QGLWidget
{
    Q_OBJECT

public:
    Tetrahedron(QWidget *parent = 0);
	QMovie *movie;
    //
    GLfloat debut_px;
    GLfloat debut_py;
    GLfloat debut_pz;
    GLfloat debut_rx;
    GLfloat debut_ry;
    GLfloat debut_rz;
    //
    GLfloat fin_px;
    GLfloat fin_py;
    GLfloat fin_pz;
    GLfloat fin_rx;
    GLfloat fin_ry;
    GLfloat fin_rz;
    //
    GLfloat delta_px;
    GLfloat delta_py;
    GLfloat delta_pz;
    GLfloat delta_rx;
    GLfloat delta_ry;
    GLfloat delta_rz;
    //
    GLfloat posanim_x;
    GLfloat posanim_y;
    GLfloat sizanim;
    GLfloat rotanim;
    int vitanim;
    int bcle_tempo;
    //
    GLfloat myvariance;
    GLfloat sensvariance;
    int x, y, z;
    float float_x, float_y, float_xb, float_yb;
    GLfloat points[ 45 ][ 45 ][3];
    QImage bufimg[202];
    int cptbuf;
    int bcle_render;
    GLfloat size_001;
    GLfloat size_002;
    GLfloat size_003;
    GLfloat size_004;
    int ismblur;
    int size_anim;
    int table_puissance[14];
    //
    GLfloat rotationX;
    GLfloat rotationY;
    GLfloat rotationZ;
    GLfloat deplacementX;
    GLfloat deplacementY;
    GLfloat zoom;
    GLfloat wg_percent;
    GLfloat wg_percent_fog;
    GLfloat wg_percent_slide;
    GLfloat start_opacity;
    GLfloat end_opacity;
    GLfloat delta_opacity;
    GLfloat start_fog_opacity;
    GLfloat end_fog_opacity;
    GLfloat delta_fog_opacity;
    //
    int type_play;
    int type3D;
    int wg_qualite;
    int frame_encoding;
    int tool;
    int isfog;
    int progress;
    int isbackanim;
    int duree;
    int poursuite;
    int wg_duree;
    int pause_debut;
    int pause_fin;
    int size_factor;
    QString path_fond;
    QString path_render;
    QString wg_tet_library;
    int numdiapo;
    int iseffect;
    int wg_cpt_001;
    QString nameanim;
    QImage a;
    QImage d;
    QImage null_img;
    QImage wg_puis_001;
    GLuint texture1;
    GLuint texture2;
    GLuint texture3;
    QString txt_sur_image;
    QFont myfont;
    QColor mycolor;
    QColor table_color[400];
    QColor txt_mycolor;
    QString wl_var_1;
    QString wl_var_2;
    int effet_titre;
    GLfloat x_titre;
    GLfloat y_titre;
    GLfloat v_titre;
    GLfloat fogcolor[4];

protected:
    void paintGL();
    void mousePressEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void wheelEvent(QWheelEvent *event);

public slots:
    void initializeGL();
    void change_fog_color();
    void sl_play();
    void sl_stop();
    void sl_charge_image(QString, QString);
    void updateMove();
    void grabgl();
    void grabframe(QString);
    void load_effet(QString);
    void sl_mark_deb();
    void sl_mark_fin();
    void resizeGL(int, int);
    void sl_change_fond(QString);
    void sl_brouillard(int);
    void sl_opacity(int);
    void sl_wait_stop();
    void sl_go_start();
    void sl_go_end();

private slots:

private:
    void draw();
    float w_x_p;
    float w_x_m;
    QImage t;
    QImage b;
    QImage c;
    QImage f;
    QPoint lastPos;
};

#endif
